package com.ekingwin.bas.cloud.solr.web;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.ekingwin.bas.cloud.solr.JiucaiyunSolrException;
import com.ekingwin.bas.cloud.solr.dto.JiucaiyunSolrRequestDTO;
import com.ekingwin.bas.cloud.solr.dto.JiucaiyunSolrResponseDTO;
import com.ekingwin.bas.cloud.solr.service.IJiucaiyunSolrService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("/solr")
@Api("solr相关基本方法api")
public class JiucaiyunSolrController {
	@Autowired
	private IJiucaiyunSolrService jiucaiyunSolrServiceImpl;

	@RequestMapping(value = "/initData", method = RequestMethod.POST)
	@ApiOperation("初始化数据")
	public Boolean initData() throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.initData();
	}

	@RequestMapping(value = "/queryData", method = RequestMethod.POST)
	@ApiOperation("查询数据")
	public JiucaiyunSolrResponseDTO queryData(@RequestBody JiucaiyunSolrRequestDTO request)
			throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.queryData(request);
	}

	@RequestMapping(value = "/productUpData/{id}", method = RequestMethod.POST)
	@ApiOperation("商品上架")
	public Boolean productUpData(@PathVariable(value = "id") String id) throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.productUpData(id);
	}

	@RequestMapping(value = "/productDownData/{id}", method = RequestMethod.POST)
	@ApiOperation("商品下架（删除）")
	public Boolean productDownData(@PathVariable(value = "id") String id) throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.productDownData(id);
	}

	@RequestMapping(value = "/destoryData", method = RequestMethod.POST)
	@ApiOperation("清空数据")
	public Boolean destoryData() throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.destoryData();
	}
	
	@RequestMapping(value = "/productUpdateSalesNum/{data}", method = RequestMethod.POST)
	@ApiOperation("更新商品数量")
	public Boolean productUpdateSalesNum(@PathVariable(value = "data") String data) throws JiucaiyunSolrException {
		return jiucaiyunSolrServiceImpl.productUpdateSalesNum(data);
	}

}
